#pragma warning (disable: 4995)
#pragma warning (disable: 4996)
#include <tchar.h>
#include "shiftDialog.h"

#include "plugin.hpp"
#include "farManager.h"
#include "ssaTime.h"
#include "helpContexts.h"
#include "language.h"

#include <algorithm>


const TCHAR* ShiftDialog::label0_;
const TCHAR* ShiftDialog::label1_;
const TCHAR* ShiftDialog::label2_;
TCHAR ShiftDialog::buf1[TIME_BUF_LEN];
TCHAR ShiftDialog::buf2[TIME_BUF_LEN];
const TCHAR* ShiftDialog::help_;
LONGLONG ShiftDialog::init1_;
LONGLONG ShiftDialog::init2_;
LONGLONG ShiftDialog::mediaTime_;
LONGLONG ShiftDialog::shift_;

ShiftDialog::ShiftDialog(const TCHAR* label0,
		const TCHAR* label1, LONGLONG init1,
		const TCHAR* label2, LONGLONG init2,
		LONGLONG mediaTime,
		const TCHAR* help)
{
	label0_ = label0;
	label1_ = label1;
	label2_ = label2;
	help_ = help;
	init1_ = init1;
	init2_ = init2;
	mediaTime_ = mediaTime;
	shift_ = 0;
}

bool ShiftDialog::execute()
{
	FarDialogItem items[] =
	{
		{ DI_TEXT,     3, 1, 15, 0, 0, 0,              0, 0, _T("Shift &by")   },
		{ DI_FIXEDIT, 18, 1, 28, 0, 1, 0,   DIF_MASKEDIT, 1, _T(" 0:00:00.00") },
		{ DI_TEXT,     3, 2, 15, 0, 0, 0,              0, 0, _T("&Start time") },
		{ DI_FIXEDIT, 19, 2, 28, 0, 0, 0,   DIF_MASKEDIT, 0, _T("")            },
		{ DI_TEXT,     3, 3, 15, 0, 0, 0,              0, 0, _T("&End time")   },
		{ DI_FIXEDIT, 19, 3, 28, 0, 0, 0,   DIF_MASKEDIT, 0, _T("")            },
		{ DI_BUTTON,  32, 1, 43, 0, 0, 0, DIF_BTNNOCLOSE, 0, _T("&Original")   },
		{ DI_BUTTON,  32, 2, 43, 0, 0, 0, DIF_BTNNOCLOSE, 0, _T("&Current ")   }
	};

#ifndef _UNICODE
	strncpy(items[0].Data, label0_, COUNTOF(items[0].Data));
	strncpy(items[2].Data, label1_, COUNTOF(items[2].Data));
	strncpy(items[4].Data, label2_, COUNTOF(items[4].Data));
#else
	items[0].PtrData = label0_;
	items[2].PtrData = label1_;
	items[3].PtrData = buf1;
	items[4].PtrData = label2_;
	items[5].PtrData = buf2;
	items[6].PtrData = *lng::timing::dialog::original;
	items[7].PtrData = *lng::timing::dialog::current;
#endif

	items[1].Mask = _T("#9:99:99.99");
	items[3].Mask = items[5].Mask = _T("9:99:99.99");

#ifndef _UNICODE
	formatTime(init1_, items[3].Data, items[3].Data + 10);
	formatTime(init2_, items[5].Data, items[5].Data + 10);
#else
	formatTime(init1_, (TCHAR*)items[3].PtrData, (TCHAR*)items[3].PtrData + 10);
	formatTime(init2_, (TCHAR*)items[5].PtrData, (TCHAR*)items[5].PtrData + 10);
#endif

	if (mediaTime_ < 0)
	{
		items[7].Flags |= DIF_DISABLE;
	}

	return -1 != farManager.dialogEx(items, COUNTOF(items), 46, 5, help_, &dialogProc);
}

void ShiftDialog::shiftChanged(HANDLE hDlg, const FarDialogItem& item)
{
#ifndef _UNICODE
	shift_ = parseTime(item.Data + 1, item.Data + 11);
	if ('-' == item.Data[0]) shift_ = -shift_;
#else
	shift_ = parseTime(item.PtrData + 1, item.PtrData + 11);
	if (L'-' == item.PtrData[0]) shift_ = -shift_;
#endif

	TCHAR buf[11];

	formatTime((std::max)(0LL, shift_ + init1_), buf, buf + 10); buf[10] = 0;
	farManager.setTextPtr(hDlg, 3, buf);

	formatTime((std::max)(0LL, shift_ + init2_), buf, buf + 10);
	farManager.setTextPtr(hDlg, 5, buf);
}

void ShiftDialog::time1Changed(HANDLE hDlg, const FarDialogItem& item)
{
#ifndef _UNICODE
	LONGLONG time1 = parseTime(item.Data, item.Data + 10);
#else
	LONGLONG time1 = parseTime(item.PtrData, item.PtrData + 10);
#endif
	shift_ = time1 - init1_;

	TCHAR buf[12];

	buf[0] = shift_ < 0 ? '-' : ' ';
	formatTime(_abs64(shift_), buf + 1, buf + 11);
	buf[11] = 0;
	farManager.setTextPtr(hDlg, 1, buf);

	formatTime((std::max)(0LL, shift_ + init2_), buf, buf + 10);
	buf[10] = 0;
	farManager.setTextPtr(hDlg, 5, buf);
}
void ShiftDialog::time2Changed(HANDLE hDlg, const FarDialogItem& item)
{
#ifndef _UNICODE
	LONGLONG time2 = parseTime(item.Data, item.Data + 10);
#else
	LONGLONG time2 = parseTime(item.PtrData, item.PtrData + 10);
#endif
	shift_ = time2 - init2_;

	TCHAR buf[12];

	buf[0] = shift_ < 0 ? '-' : ' ';
	formatTime(_abs64(shift_), buf + 1, buf + 11);
	buf[11] = 0;
	farManager.setTextPtr(hDlg, 1, buf);

	formatTime((std::max)(0LL, shift_ + init1_), buf, buf + 10);
	buf[10] = 0;
	farManager.setTextPtr(hDlg, 3, buf);
}

void ShiftDialog::originalClick(HANDLE hDlg)
{
	shift_ = 0LL;
	farManager.setTextPtr(hDlg, 1, _T(" 0:00:00.00"));

	TCHAR buf[11];

	formatTime(init1_, buf, buf + 10);
	buf[10] = 0;
	farManager.setTextPtr(hDlg, 3, buf);

	formatTime(init2_, buf, buf + 10);
	farManager.setTextPtr(hDlg, 5, buf);
}

void ShiftDialog::currentClick(HANDLE hDlg)
{
	shift_ = mediaTime_ - init1_;

	TCHAR buf[12];

	buf[0] = shift_ < 0 ? '-' : ' ';
	formatTime(_abs64(shift_), buf + 1, buf + 11);
	buf[11] = 0;
	farManager.setTextPtr(hDlg, 1, buf);

	formatTime((std::max)(0LL, shift_ + init1_), buf, buf + 10);
	buf[10] = 0;
	farManager.setTextPtr(hDlg, 3, buf);

	formatTime((std::max)(0LL, shift_ + init2_), buf, buf + 10);
	buf[10] = 0;
	farManager.setTextPtr(hDlg, 5, buf);
}

long WINAPI ShiftDialog::dialogProc(HANDLE hDlg, int Msg, int Param1, long Param2)
{
	static bool bModif;

	switch (Msg)
	{
	case DN_EDITCHANGE:
		switch (Param1)
		{
		case 1:
			if (!bModif) {
				bModif = true;
				shiftChanged(hDlg, *reinterpret_cast<FarDialogItem*>(Param2));
				bModif = false;
			}
			break;
		case 3:
			if (!bModif) {
				bModif = true;
				time1Changed(hDlg, *reinterpret_cast<FarDialogItem*>(Param2));
				bModif = false;
			}
			break;
		case 5:
			if (!bModif) {
				bModif = true;
				time2Changed(hDlg, *reinterpret_cast<FarDialogItem*>(Param2));
				bModif = false;
			}
			break;
		}
		break;
	case DN_BTNCLICK:
		switch (Param1)
		{
		case 6:
			originalClick(hDlg);
			break;
		case 7:
			currentClick(hDlg);
			break;
		}
		break;
	}
	return farManager.defDlgProc(hDlg, Msg, Param1, Param2);
}
