#ifndef SHIFT_DIALOG_INCLUDED
#define SHIFT_DIALOG_INCLUDED

#include <windows.h>

#include "plugin.hpp"

class ShiftDialog
{
public:
	ShiftDialog(const TCHAR* label0,
		const TCHAR* label1, LONGLONG init1,
		const TCHAR* label2, LONGLONG init2,
		LONGLONG mediaTime,
		const TCHAR* help);
	bool execute();
	LONGLONG shift() const
	{
		return shift_;
	}
private:
	static const int TIME_BUF_LEN=512;
	static const TCHAR* label0_;
	static const TCHAR* label1_;
	static const TCHAR* label2_;
	static TCHAR buf1[TIME_BUF_LEN];
	static TCHAR buf2[TIME_BUF_LEN];
	static const TCHAR* help_;
	static LONGLONG init1_, init2_, mediaTime_, shift_;
	static long WINAPI dialogProc(HANDLE hDlg, int Msg, int Param1, long Param2);

	static void shiftChanged(HANDLE hDlg, const FarDialogItem& item);
	static void time1Changed(HANDLE hDlg, const FarDialogItem& item);
	static void time2Changed(HANDLE hDlg, const FarDialogItem& item);

	static void originalClick(HANDLE hDlg);
	static void  currentClick(HANDLE hDlg);
};

#endif
